/**
 * 项目管理-列表
 */
shr.defineClass("shr.project.projectManagementList",shr.framework.List,{
	initalizeDOM : function() {
		shr.project.projectManagementList.superClass.initalizeDOM.call(this);
		var _self = this;
	},
	
	/**
	 * 启用
	 */
	enableAction : function(){
		var that = this;
		var billIds = $("#grid").jqGrid("getSelectedRows");
		if (billIds == undefined || billIds.length == 0 || (billIds && billIds.length == 1 && billIds[0] == "")) {
			shr.showWarning({
				message : "请先选中一行数据！",
				hideAfter : 5
			})
			return;
		} else {
			for(var i = 0; i < billIds.length; i++) {
				var state = $("#grid").jqGrid("getCell",billIds[i], "projectState"); 
				if(state && state != '未启用' && state != '禁用' && state != "0" && state != "3"){
					shr.showWarning({
						message : '只能启用“未启用”、“禁用”的项目！',
						hideAfter : 5
					});
					return ;
				}
			}
			shr.showConfirm('确认启用项目？', function() {
				top.Messenger().hideAll();
				that.doRemoteWithBatchAction({
					method : "enablePorject",
					billId : billIds.toString()
				});
			});
		}
	},
	
	/**
	 * 禁用
	 */
	disableAction : function(){
		var that = this;
		var billIds = $("#grid").jqGrid("getSelectedRows");
		if (billIds == undefined || billIds.length == 0 || (billIds && billIds.length == 1 && billIds[0] == "")) {
			shr.showWarning({
				message : "请先选中一行数据！",
				hideAfter : 5
			})
			return;
		} else {
			for(var i = 0; i < billIds.length; i++) {
				var state = $("#grid").jqGrid("getCell",billIds[i], "projectState"); 
				if(state && state != '已启用' && state != "1"){
					shr.showWarning({
						message : '只能禁用“进行中”的项目！！',
						hideAfter : 5
					});
					return ;
				}
			}
			var confirmMsg = '确认禁用项目？';
			shr.showConfirm(confirmMsg, function() {
				top.Messenger().hideAll();
				that.doRemoteWithBatchAction({
					method : "disableProject",
					billId : billIds.toString()
				});
			});
		}
	},
	/**
	 * 描述:删除操作
	 * 
	 * @action
	 */
	deleteAction : function() {
		var that = this;
		var billIds = $("#grid").jqGrid("getSelectedRows");
		if (billIds == undefined || billIds.length == 0 || (billIds && billIds.length == 1 && billIds[0] == "")) {
			shr.showWarning({
				message : "请先选中一行数据！",
				hideAfter : 5
			})
			return;
		} else {
			for(var i = 0; i < billIds.length; i++) {
				var state = $("#grid").jqGrid("getCell",billIds[i], "projectState"); 
				if(state && state != '未启用' && state != '禁用' && state != "0" && state != "3"){
					shr.showWarning({
						message : '只能删除“未启用”、“禁用”的项目！',
						hideAfter : 5
					});
					return ;
				}
			}
			var confirmMsg = '是否确认删除所选项目？';
			shr.showConfirm(confirmMsg, function() {
				top.Messenger().hideAll();
				that.doRemoteWithBatchAction({
					method : "deleteOne",
					billId : billIds.toString()
				});
			});
		}
	}
});

