package com.kingdee.eas.hr.perf.task;

import com.kingdee.bos.metadata.MetaDataLoaderFactory;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.management.LanguageCollection;
import com.kingdee.bos.metadata.management.SolutionInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.service.message.Message;
import com.kingdee.bos.service.message.agent.MessageFactory;
import com.kingdee.bos.service.message.agent.SenderAgent;
import com.kingdee.eas.base.message.MsgBizType;
import com.kingdee.eas.base.message.MsgPriority;
import com.kingdee.eas.base.message.MsgSourceStatus;
import com.kingdee.eas.base.message.MsgType;
import com.kingdee.eas.base.permission.UserInfo;
import com.kingdee.eas.csinterface.biz.util.DBUtils;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.perfweb.app.base.evalplan.*;
import org.apache.log4j.Logger;

import javax.ejb.*;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.util.*;

import com.kingdee.bos.*;
import com.kingdee.bos.util.BOSObjectType;
import com.kingdee.bos.metadata.IMetaDataPK;
import com.kingdee.bos.metadata.rule.RuleExecutor;
import com.kingdee.bos.metadata.MetaDataPK;
//import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.framework.ejb.AbstractEntityControllerBean;
import com.kingdee.bos.framework.ejb.AbstractBizControllerBean;
//import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.IObjectCollection;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.bos.service.IServiceContext;


public class PerInterviewFacadeControllerBean extends AbstractPerInterviewFacadeControllerBean {
    private static Logger logger =
            Logger.getLogger("com.kingdee.eas.hr.perf.task.PerInterviewFacadeControllerBean");

    @Override
    protected void _sendEarlyWarning(Context ctx) throws BOSException {
        super._sendEarlyWarning(ctx);
        //˵ȼ
        Set levelSet = new HashSet();
        levelSet.add("C");
        levelSet.add("D");
        Map evaResultSummaryMap = null;
        try {
            //˽
            IEvaResultSummary iEvaResultSummary = EvaResultSummaryFactory.getLocalInstance(ctx);
            //̸
            IInterview iInterview = InterviewFactory.getLocalInstance(ctx);
            Map interviewMap = new HashMap();
            InterviewCollection interviewCollection = iInterview.getInterviewCollection();
            for (int i = 0; i < interviewCollection.size(); i++) {
                InterviewInfo interviewInfo = interviewCollection.get(i);
                String evaResultSummaryId = interviewInfo.getEvaResultSummary().getId().toString();
                interviewMap.put(evaResultSummaryId, interviewInfo);
            }
            //ȡ˵ֱϼ
            Map personOfParentMap = getPersonOfParentAll(ctx);
            //ȡЧ˵ȼΪC/D
            SelectorItemCollection sic = getSelectorItemCollection();
            FilterInfo filterInfo = new FilterInfo();
            FilterItemCollection filterItems = filterInfo.getFilterItems();
            filterItems.add(new FilterItemInfo("gradeLevel", levelSet, CompareType.INCLUDE));
            EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
            EvaResultSummaryCollection evaResultSummaryCollection = iEvaResultSummary.getEvaResultSummaryCollection(entityViewInfo);
            //
            StringBuilder body = new StringBuilder();
            evaResultSummaryMap = new HashMap();
            for (int i = 0; i < evaResultSummaryCollection.size(); i++) {
                EvaResultSummaryInfo evaResultSummaryInfo = evaResultSummaryCollection.get(i);
                String id = evaResultSummaryInfo.getId().toString();
                String number = evaResultSummaryInfo.getNumber();
                String personId = evaResultSummaryInfo.getPerson().getId().toString();
                String personName = evaResultSummaryInfo.getPerson().getName();
                String gradeLevel = evaResultSummaryInfo.getGradeLevel().toString();
                if (!interviewMap.containsKey(id)) {
                    evaResultSummaryMap.put(number, evaResultSummaryInfo);
                    evaResultSummaryMap.put(personId, personOfParentMap.get(personId));
                    body.append("Ա:[").append(personName).append("]ЧΪ").append(gradeLevel).append(",δмЧ̸뼰ʱ").append("\n");
                }
            }
            sendMessage(ctx, body.toString());
        } catch (SQLException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
    }

    /**
     * Ϣ
     *
     * @param ctx
     * @param body
     */
    public void sendMessage(Context ctx, String body) {
        logger.error("start-----");
        UserInfo currentUserInfo = ContextUtil.getCurrentUserInfo(ctx);
        //ǷһϢĺƬϣԵĳ֯ͣԼҪȡ֯ûIDϣȻreceiver
        SenderAgent senderAgent = SenderAgent.getSenderAgent();
        Message message;
        Locale[] lcla = getContextLocales(ctx);//ȡctxϢб
        logger.error("lcla---" + lcla);
        Locale locale = null;
        message = MessageFactory.newMessage("kingdee.workflow");//һϢ
        for (int j = 0, m = lcla.length; j < m; j++) {
            //˴ѭжϢ
            locale = lcla[j];
            message.setLocaleStringHeader("title", "ЧԤ", locale);//Ϣ
            message.setLocaleStringHeader("sender", "רԱ", locale);//÷ˣıID
            message.setLocaleStringHeader("body", body, locale);//ϢݣݾҵԼ趨
            message.setLocaleStringHeader("initiatorName", "רԱ", locale);

        }
        message.setIntHeader("type", MsgType.NOTICE_VALUE);//ϢΪ֪ͨ
        message.setIntHeader("bizType", MsgBizType.FORWARN_VALUE);//ҵΪ
        message.setIntHeader("sourceStatus", MsgSourceStatus.EMPTY_VALUE);//״̬˴֪ͨϢÿ
        message.setIntHeader("priority", MsgPriority.MIDDLE_VALUE);//ϢȼԼҪ趨Ӧļ
        message.setStringHeader("databaseCenter", ctx.getAIS());//õ
        message.setStringHeader("solution", ctx.getSolution());//ý
        //ýߣǲûIDID÷ֺ";"ָ
        message.setStringHeader("receiver", currentUserInfo.getId().toString());
        logger.error("senderAgent.getState() -----" + senderAgent.getState());
        if (senderAgent.getState() == 1) {
            senderAgent.start();
        }
        senderAgent.sendMessage(message); //Ϣ
        logger.error("end-----");

    }

    /**
     * ȡctxϢб
     *
     * @param ctx
     * @return
     */
    public static Locale[] getContextLocales(Context ctx) {
        Locale[] locales = null;
        SolutionInfo solu = MetaDataLoaderFactory.getLocalMetaDataLoader(ctx)
                .getSolution();

        if (solu != null) {
            LanguageCollection langs = solu.getLanguages();
            if (langs != null) {

                locales = new Locale[langs.size()];

                for (int i = 0; i < langs.size(); i++) {
                    locales[i] = langs.get(i).getLocale();
                }
            }
        }

        return locales;
    }

    /**
     * ȡԱֱϼ
     *
     * @param ctx
     * @return
     * @throws BOSException
     * @throws SQLException
     */
    public Map getPersonOfParentAll(Context ctx) throws BOSException, SQLException {
        StringBuilder sb = new StringBuilder();
        Map map = new HashMap();
        sb.append("select ").append("\n");
        sb.append("personParent.fnumber as personParentNumber , ").append("\n");
        sb.append("personParent.fid as personParentId , ").append("\n");
        sb.append("personParent.fname_l2  as personParentName , ").append("\n");
        sb.append("person.fnumber as personNumber , ").append("\n");
        sb.append("person.fid as personId , ").append("\n");
        sb.append("person.fname_l2  as personName ").append("\n");
        sb.append("from T_ORG_PositionMember positioonMenber").append("\n");
        sb.append("    left join T_ORG_Position position on position.fid = positioonMenber.FPositionID").append("\n");
        sb.append("    left join T_ORG_Position positionParent on position.fid = positionParent.FPARENTID").append("\n");
        sb.append("    left join T_HR_EmpOrgRelation empOrgRelation on empOrgRelation.FPOSITIONID  = positionParent.fid").append("\n");
        sb.append("    left join t_Bd_person person on person.fid = empOrgRelation.FPERSONID and empOrgRelation.FIsSystem='1'").append("\n");
        sb.append("    left join t_Bd_person personParent on  personParent.fid = positioonMenber.FPERSONID").append("\n");
        IRowSet iRowSet = DBUtils.executeQuery(ctx, sb.toString());
        while (iRowSet.next()) {
            map.put(iRowSet.getString("personId"), iRowSet.getString("personParentId"));
        }
        return map;
    }

    /**
     * ѯֶ
     *
     * @return
     */
    public SelectorItemCollection getSelectorItemCollection() {
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("gradeLevel");//˵ȼ
        sic.add("id");//˵ȼ
        sic.add("name");//Ա
        sic.add("number");//Ա
        sic.add("evaObj.id");//
        sic.add("evaObj.name");
        sic.add("evaObj.number");
        sic.add("evaPlan.id");//˼ƻ
        sic.add("evaPlan.name");
        sic.add("evaPlan.number");
        sic.add("period.id");//
        sic.add("period.name");
        sic.add("period.number");
        sic.add("period.id");//
        sic.add("period.name");
        sic.add("period.number");
        sic.add("person.id");//Ա
        sic.add("person.name");
        sic.add("person.number");
        return sic;
    }

}
