package com.kingdee.eas.hr.perf.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.perf.IPerformProTeam;
import com.kingdee.eas.hr.perf.PerformProTeamCollection;
import com.kingdee.eas.hr.perf.PerformProTeamFactory;
import com.kingdee.shr.base.syssetting.BaseItemException;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Set;

/**
 * @author qingwu
 * @date 2024/12/24
 * @apiNote
 */
public class PerformProTeamListHandler extends ListHandler {
    Context ctx = SHRContext.getInstance().getContext();

    @Override
    public String deleteAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        String billId = this.getBillId(request);
        Set<String> set = AtsUtil.toSet(billId);
        FilterInfo filterInfo = new FilterInfo();
        filterInfo.getFilterItems().add(new FilterItemInfo("id", set, CompareType.INCLUDE));
        filterInfo.getFilterItems().add(new FilterItemInfo("status", "1", CompareType.EQUALS));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, null, null);
        try {
            IPerformProTeam iPerformProTeam = PerformProTeamFactory.getLocalInstance(ctx);
            PerformProTeamCollection performProTeamCollection = iPerformProTeam.getPerformProTeamCollection(entityViewInfo);
            if (performProTeamCollection.size() > 0) {
                throw new ShrWebBizException("ݲɾ");
            }
        } catch (BOSException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
        return super.deleteAction(request, response, modelMap);
    }
}
