package com.kingdee.eas.hr.perf.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.perf.*;
import com.kingdee.shr.base.syssetting.BaseItemException;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.handler.EditHandler;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Set;

/**
 * @author qingwu
 * @date 2024/12/11
 * @apiNote
 */
public class PersonPerformProListHandler extends ListHandler {
    Context ctx = SHRContext.getInstance().getContext();

    @Override
    public String deleteAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        String billId = this.getBillId(request);
        Set<String> set = AtsUtil.toSet(billId);
        FilterInfo filterInfo = new FilterInfo();
        filterInfo.getFilterItems().add(new FilterItemInfo("id", set, CompareType.INCLUDE));
        filterInfo.getFilterItems().add(new FilterItemInfo("state", "1", CompareType.EQUALS));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, null, null);
        try {
            IPersonPerformPro iPersonPerformPro = PersonPerformProFactory.getLocalInstance(ctx);
            PersonPerformProCollection performProTeamCollection = iPersonPerformPro.getPersonPerformProCollection(entityViewInfo);
            if (performProTeamCollection.size() > 0) {
                throw new ShrWebBizException("ݲɾ!");
            }
        } catch (BOSException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
        return super.deleteAction(request, response, modelMap);
    }
}
