package com.kingdee.eas.hr.perf.utils;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ObjectNotFoundException;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.shr.base.syssetting.api.bean.BatchMessageTipsBody;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.util.LocaleUtils;
import com.kingdee.shr.perfweb.app.base.evalfile.PerfFileCollection;
import com.kingdee.shr.perfweb.app.base.evalfile.PerfFileFactory;
import com.kingdee.shr.perfweb.app.base.evalfile.PerfFileInfo;
import com.kingdee.shr.perfweb.app.base.evalplan.*;
import com.kingdee.shr.perfweb.app.base.evalrule.PWorkFlowDefCollection;
import com.kingdee.shr.perfweb.app.base.evalrule.PWorkFlowDefInfo;
import com.kingdee.shr.perfweb.app.base.evalrule.PerformanceRuleInfo;
import com.kingdee.shr.perfweb.app.exception.SHRPerfWebBizException;
import com.kingdee.shr.perfweb.app.resource.SHRPerfWebResource;
import com.kingdee.shr.perfweb.util.PerfEvaObjGroupUtils;
import com.kingdee.shr.perfweb.util.PerfRuleSettingUtil;
import com.kingdee.shr.perfweb.util.PersonInchargeUtils;
import com.kingdee.shr.perfweb.util.SHRPerfWebResourceUtil;
import com.kingdee.shr.perfweb.utils.PerfPlanUtils;
import com.kingdee.shr.perfweb.utils.RuleHistoryUtils;
import org.apache.log4j.Logger;
import org.springframework.util.CollectionUtils;

import java.util.*;

/**
 * @author qingwu
 * @date 2024/12/25
 * @apiNote
 */
public class PerfEvaObjectUtils {
    private static Logger logger =
            Logger.getLogger(PerfEvaObjectUtils.class);

    /**
     * @param ctx
     * @param perfFiles ԱԱ
     * @param periodId  id
     * @param hrOrgUnit Ĭϣ00000000-0000-0000-0000-000000000000CCE7AED4
     * @param perfPlan  ˼ƻID
     * @throws SHRWebException
     */
    public void addFromPerfFile(Context ctx, String perfFiles, String periodId, String hrOrgUnit, PerfPlanInfo perfPlan) throws SHRWebException {
        logger.error("addFromPerfFile----");
        String billId = perfFiles;
        //String billId = "nJsYSsgcTvqTNTFmY+YCRFulBK0=";
        checkPeriod(periodId);
        String[] ids = null;
        ids = billId.split(",");
        Set<String> set = new HashSet();
        set.addAll(Arrays.asList(ids));
        EntityViewInfo viewInfo = new EntityViewInfo();
        FilterInfo filter = new FilterInfo();
        SelectorItemCollection sic = viewInfo.getSelector();
        sic.add(new SelectorItemInfo("*"));
        sic.add(new SelectorItemInfo("position.id"));
        sic.add(new SelectorItemInfo("adminOrgUnit.id"));
        sic.add(new SelectorItemInfo("hrOrgUnit.id"));
        sic.add(new SelectorItemInfo("person.number"));
        sic.add(new SelectorItemInfo("person.name"));
        sic.add(new SelectorItemInfo("empPosOrgRelation.*"));
        filter.getFilterItems().add(new FilterItemInfo("id", set, CompareType.INCLUDE));
        viewInfo.setFilter(filter);
        PerfFileCollection coll = null;
        PerfGoalsGroupCollection groupColl = null;
        String groupId = "";
        PWorkFlowDefInfo defaultWorkFlow = null;

        try {
            coll = PerfFileFactory.getRemoteInstance().getPerfFileCollection(viewInfo);
            groupColl = PerfGoalsGroupFactory.getRemoteInstance().getPerfGoalsGroupCollection("where period = '" + periodId + "' and useDefault = 1");
            if (groupColl != null && groupColl.get(0) != null) {
                groupId = groupColl.get(0).getId().toString();
            }

            PerfPeriodInfo perfPeriodInfo = PerfPeriodFactory.getRemoteInstance().getPerfPeriodInfo("where id = '" + periodId + "'");
            PerformanceRuleInfo perfRule = perfPeriodInfo.getPerfRule();
            PWorkFlowDefCollection pWFDefColl = RuleHistoryUtils.getDefaultWorkFlow(ctx, perfRule.getId().toString());
            if (pWFDefColl != null && pWFDefColl.size() > 0) {
                defaultWorkFlow = pWFDefColl.get(0);
            } else if (perfPeriodInfo.getIsHistoryUpdate().getValue() == 1) {
                defaultWorkFlow = perfPlan.getDefaultWorkFlow();
            }
        } catch (BOSException var20) {
            var20.printStackTrace();
            logger.error(var20.toString());
        } catch (EASBizException var21) {
            var21.printStackTrace();
            logger.error(var21.toString());
        }

        if (coll != null && defaultWorkFlow != null) {
            CoreBaseCollection croeBase = new CoreBaseCollection();

            for (int i = 0; i < coll.size(); ++i) {
                PerfEvaObjectInfo info = new PerfEvaObjectInfo();
                PerfFileInfo fileInfo = coll.get(i);
                info.put("number", fileInfo.getPerson().getNumber());
                info.setName(fileInfo.getPerson().getName());
                info.setName(fileInfo.getPerson().getName(LocaleUtils.locale_l1), LocaleUtils.locale_l1);
                info.setName(fileInfo.getPerson().getName(LocaleUtils.locale_l2), LocaleUtils.locale_l2);
                info.setName(fileInfo.getPerson().getName(LocaleUtils.locale_l3), LocaleUtils.locale_l3);
                info.put("period", periodId);
                info.setCanAdjustEvaluer(TargetEvaluModeEnum.getEnum(perfPlan.getCanAdjustEvaluer().getValue()));
                info.setHrUnitOrg(fileInfo.getHrOrgUnit());
                info.setPerfFile(fileInfo);
                info.setAdminOrgUnit(fileInfo.getAdminOrgUnit());
                info.put("person", fileInfo.getPerson());
                info.put("joinPeriodDate", new Date());
                info.put("joinPlanDate", new Date());
                info.put("changeDealType", 100);
                info.put("workFlow", defaultWorkFlow.getId().toString());
                info.put("unitGoalsStatus", "0");
                info.put("belongGroup", groupId);
                info.setScoreTaskStatus(ScoreTaskStatusEnum.UNSEND);
                info.setTargetMakeSure(perfPlan.isTargetMakeSure() ? 1 : 0);
                info.setPersonInChargeType(PersonInchargeUtils.setSuperior2PersonInChargeType(info.getPersonInChargeType()));
                info.setPersonInchargePosition((String) null);
                info.setPointPosition((String) null);
                info.put("personIncharge", new PerfEvaPersonInchargeCollection());
                croeBase.add(info);
            }

            this.runBatchSaveEvaObject(ctx, periodId, hrOrgUnit, croeBase);
        } else {
            throw new SHRWebException((new SHRPerfWebBizException(SHRPerfWebBizException.GETERR)).getMessage());
        }
    }

    protected void runBatchSaveEvaObject(Context ctx, String periodId, String hrOrgUnit, CoreBaseCollection croeBase) throws SHRWebException {
        logger.error("runBatchSaveEvaObject----");
        int sucess = 0;
        int failure = 0;
        String billId = "";
        try {
            Set<String> sucessIds = new HashSet();
            Map<String, String> verifyMap = new HashMap();
            Map<String, String> evaPlanNameMap = this.getPerfPlanName(ctx, periodId, hrOrgUnit);
            CoreBaseCollection addCoreColl = new CoreBaseCollection();
            int count = croeBase.size();
            int j = 1;
            Set<String> personIds = new HashSet();

            int i;
            PerfEvaObjectInfo info;
            for (i = 0; i < count; ++i) {
                info = (PerfEvaObjectInfo) croeBase.get(i);
                personIds.add(info.getPerson().getId().toString());
                if (j != 500 && i != count - 1) {
                    ++j;
                } else {
                    Map<String, String> tempMap = this.getEvaObject(ctx, periodId, hrOrgUnit, personIds);
                    if (!CollectionUtils.isEmpty(tempMap)) {
                        verifyMap.putAll(tempMap);
                    }

                    j = 1;
                    personIds = new HashSet();
                }
            }
            IObjectPK[] iObjectPKS = null;
            for (i = 0; i < croeBase.size(); ++i) {
                info = (PerfEvaObjectInfo) croeBase.get(i);
                BatchMessageTipsBody body = new BatchMessageTipsBody();

                try {
                    String id = info.getPerfFile().getId().toString();
                    billId = billId + id + ",";
                    body.setId(id);
                    if (sucessIds.contains(id)) {
                        continue;
                    }

                    sucessIds.add(id);

                    String key = info.getPerson().getNumber() + "_" + info.getPerson().getName() + "_" + info.getPerfFile().getPosition().getId().toString() + "_" + info.getPerfFile().getAssignType().getValue();
                    if (!org.apache.commons.lang.StringUtils.isEmpty((String) verifyMap.get(key))) {
                        continue;
                        //throw new BOSException((new SHRPerfWebBizException(SHRPerfWebBizException.EVAOBJALREADYADDED, new Object[]{evaPlanNameMap.get(verifyMap.get(key))})).getMessage());
                    }

                    addCoreColl.add(info);
                    ++sucess;
                    body.setMuitTipsState(Boolean.TRUE);
                    body.setMuitTipsMessage(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.OPERATESUCCESS, ctx));
                } catch (Exception var23) {
                    var23.printStackTrace();
                    croeBase.removeObject(i);
                    --i;
                    ++failure;
                    body.setMuitTipsState(Boolean.FALSE);
                    if (var23 instanceof ObjectNotFoundException) {
                        body.setMuitTipsMessage(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.DATADELETED, ctx));
                    } else {
                        body.setMuitTipsMessage(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.OPERATEFAILED, ctx));
                    }

                    logger.error(var23.getMessage(), var23);
                }

                if (addCoreColl.size() == 100) {
                    iObjectPKS = PerfEvaObjectFactory.getRemoteInstance().saveBatchData(addCoreColl);
                    addCoreColl.clear();
                }
            }

            if (addCoreColl.size() > 0) {
                iObjectPKS = PerfEvaObjectFactory.getRemoteInstance().saveBatchData(addCoreColl);
                addCoreColl.clear();
            }

            if (sucess > 0) {
                PerfPlanUtils.writeRefStateForPerfPeriod(ctx, periodId, RefStatusEnum.REFERED);
            }
            if (iObjectPKS != null) {
                //setUpGroups(ctx, iObjectPKS);
            }
        } catch (Exception var24) {
            logger.error("runBatchSaveEvaObject----" + var24);
            var24.printStackTrace();
            throw new SHRWebException(var24.getMessage(), var24);
        }
        logger.error("runBatchSaveEvaObject----end");

    }

    /**
     * ÷
     *
     * @param ctx
     * @param iObjectPKS
     */
    public void setUpGroups(Context ctx, IObjectPK[] iObjectPKS) throws BOSException, EASBizException, ShrWebBizException {
        IPerfGoalsGroup iPerfGoalsGroup = PerfGoalsGroupFactory.getLocalInstance(ctx);
        PerfGoalsGroupInfo perfGoalsGroupInfo = iPerfGoalsGroup.getPerfGoalsGroupInfo("where number = '20241105001'");
        String goalsGroupId = perfGoalsGroupInfo.getId().toString();
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < iObjectPKS.length; i++) {
            IObjectPK iObjectPK = iObjectPKS[i];
            sb.append(iObjectPK.toString()).append(",");
        }
        sb.deleteCharAt(sb.lastIndexOf(","));
        String groupId = goalsGroupId;
        if (!PerfEvaObjGroupUtils.checkGroupIsValid(ctx, groupId)) {
            throw new ShrWebBizException((new SHRPerfWebBizException(SHRPerfWebBizException.INDECATORNOTSAVEDINSELECTGROUP)).getMessage());
        } else {
            try {
                CoreBaseCollection perfEvaObjColl = new CoreBaseCollection();
                IPerfEvaObject iPerfEvaObject = PerfEvaObjectFactory.getRemoteInstance();
                Set<String> billIds = new HashSet();
                Set<String> fails = new HashSet();
                String billId = sb.toString();
                billIds.addAll(Arrays.asList(billId.split(",")));
                PerfEvaObjectCollection coll = getPerfEvaObjectCollectionByIds(billIds);
                if (coll != null && coll.size() > 0) {
                    String periodId = coll.get(0).getPeriod().getId().toString();
                    PerfPeriodInfo perfPeriodInfo = PerfPeriodFactory.getRemoteInstance().getPerfPeriodInfo("select perfPlan.id,perfRule.id where id = '" + periodId + "'");
                    String perfRuleId = perfPeriodInfo.getPerfRule().getId().toString();
                    Map<String, Object> checkResult = PerfRuleSettingUtil.checkRuleData(perfRuleId, "", perfPeriodInfo.getPerfPlan().getId().toString(), ctx);
                    boolean flag = (Boolean) checkResult.get("result");
                    String reMsg = "";
                    if (!flag) {
                        //addBatchMessageTips(billIds, (String) checkResult.get("msg"), batchMessageTipsHeader);
                    } else {
                        int i = 0;

                        while (true) {
                            if (i >= coll.size()) {
                                iPerfEvaObject.updateBatchData(perfEvaObjColl);
                                break;
                            }

                            PerfEvaObjectInfo evaObjInfo = coll.get(i);
                            PerfEvaObjectUnitGoalsStatusEnum unitGoalsStatus = evaObjInfo.getUnitGoalsStatus();
                            if (unitGoalsStatus != null && unitGoalsStatus.getValue() == 1) {
                                fails.add(evaObjInfo.getId().toString());
                            } else {
                                evaObjInfo.setBelongGroup(groupId);
                                perfEvaObjColl.add(evaObjInfo);
                            }

                            ++i;
                        }
                    }
                }

            } catch (BOSException var22) {
                logger.error("", var22);
                throw new ShrWebBizException((new SHRPerfWebBizException(SHRPerfWebBizException.SYSTEMERR)).getMessage());
            } catch (EASBizException var23) {
                logger.error("", var23);
                throw new ShrWebBizException((new SHRPerfWebBizException(SHRPerfWebBizException.SYSTEMERR)).getMessage());
            }
        }
    }

    private static PerfEvaObjectCollection getPerfEvaObjectCollectionByIds(Set<String> billIds) throws BOSException {
        FilterInfo filterInfo = new FilterInfo();
        filterInfo.getFilterItems().add(new FilterItemInfo("id", billIds, CompareType.INCLUDE));
        EntityViewInfo evi = new EntityViewInfo();
        evi.setFilter(filterInfo);
        IPerfEvaObject iPerfEvaObject = PerfEvaObjectFactory.getRemoteInstance();
        return iPerfEvaObject.getPerfEvaObjectCollection(evi);
    }

    public static void checkPeriod(String period) throws SHRWebException {
        if (org.apache.commons.lang.StringUtils.isEmpty(period)) {
            throw new ShrWebBizException((new SHRPerfWebBizException(SHRPerfWebBizException.PERFPERIODNOTEXIST)).getMessage());
        } else {
            PerfPeriodInfo info = null;

            try {
                info = PerfPeriodFactory.getRemoteInstance().getPerfPeriodInfo("where id = '" + period + "'");
            } catch (Exception var3) {
                logger.error(var3.toString());
                throw new ShrWebBizException((new SHRPerfWebBizException(SHRPerfWebBizException.GETPERIODDATAERR)).getMessage());
            }

            if (info.getEvaPeriodStatus().getValue() == 100) {
                throw new ShrWebBizException((new SHRPerfWebBizException(SHRPerfWebBizException.OPERATENOTALLOWEDASPERIODISEND)).getMessage());
            }
        }
    }

    public Map<String, String> getPerfPlanName(Context ctx, String period, String hrOrgUnit) throws EASBizException, BOSException {
        String oql = this.getExistPerfplanSql(ctx, period, hrOrgUnit);
        Map<String, String> map = new HashMap();
        EntityViewInfo viewInfo = new EntityViewInfo();
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add(new SelectorItemInfo("id"));
        sic.add(new SelectorItemInfo("name"));
        FilterInfo filter = new FilterInfo();
        filter.getFilterItems().add(new FilterItemInfo("id", oql, CompareType.INNER));
        viewInfo.setFilter(filter);
        viewInfo.setSelector(sic);
        PerfPlanCollection coll = PerfPlanFactory.getRemoteInstance().getPerfPlanCollection(viewInfo);

        for (int i = 0; i < coll.size(); ++i) {
            map.put(coll.get(i).getId().toString(), coll.get(i).getName());
        }

        return map;
    }

    private String getExistPerfplanSql(Context ctx, String periodId, String hrOrgUnit) throws BOSException, EASBizException {
        PerfPeriodInfo perfPeriodInfo = null;
        PerfPlanInfo planInfo = null;
        perfPeriodInfo = PerfPeriodFactory.getLocalInstance(ctx).getPerfPeriodInfo(new ObjectUuidPK(periodId));
        planInfo = PerfPlanFactory.getLocalInstance(ctx).getPerfPlanInfo(new ObjectUuidPK(perfPeriodInfo.getPerfPlan().getId().toString()));
        String sql = " select tt.fid from t_eva_perfperiod t   inner join t_eva_perfplan tt     on t.fperfplan = tt.fid   where t.fnumber ='" + perfPeriodInfo.getNumber() + "'     and tt.fperfmodelid = '" + planInfo.getPerfModel().getId().toString() + "'    and tt.FHrUnitOrgID = '" + hrOrgUnit + "'";
        return sql;
    }

    protected Map<String, String> getEvaObject(Context ctx, String period, String hrOrgUnit, Set<String> personIds) throws EASBizException, BOSException {
        String oql = this.getExistPeriodSql(ctx, period, hrOrgUnit);
        Map<String, String> map = new HashMap();
        EntityViewInfo viewInfo = new EntityViewInfo();
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add(new SelectorItemInfo("id"));
        sic.add(new SelectorItemInfo("person.name"));
        sic.add(new SelectorItemInfo("person.number"));
        sic.add(new SelectorItemInfo("perfFile.position.id"));
        sic.add(new SelectorItemInfo("perfFile.assignType"));
        sic.add(new SelectorItemInfo("period.perfplan.id"));
        FilterInfo filter = new FilterInfo();
        filter.getFilterItems().add(new FilterItemInfo("period", oql, CompareType.INNER));
        filter.getFilterItems().add(new FilterItemInfo("isOrg", 1, CompareType.NOTEQUALS));
        filter.getFilterItems().add(new FilterItemInfo("person.id", personIds, CompareType.INCLUDE));
        viewInfo.setFilter(filter);
        viewInfo.setSelector(sic);
        PerfEvaObjectCollection coll = PerfEvaObjectFactory.getRemoteInstance().getPerfEvaObjectCollection(viewInfo);

        for (int i = 0; i < coll.size(); ++i) {
            PerfEvaObjectInfo info = coll.get(i);
            if (!org.apache.commons.lang.StringUtils.isEmpty(info.getPerson().getNumber()) && info.getPerfFile().getPosition() != null && info.getPerfFile().getAssignType() != null) {
                String key = info.getPerson().getNumber() + "_" + info.getPerson().getName() + "_" + info.getPerfFile().getPosition().getId().toString() + "_" + info.getPerfFile().getAssignType().getValue();
                map.put(key, info.getPeriod().getPerfPlan().getId().toString());
            }
        }

        return map;
    }

    private String getExistPeriodSql(Context ctx, String periodId, String hrOrgUnit) throws BOSException, EASBizException {
        PerfPeriodInfo perfPeriodInfo = null;
        PerfPlanInfo planInfo = null;
        perfPeriodInfo = PerfPeriodFactory.getLocalInstance(ctx).getPerfPeriodInfo(new ObjectUuidPK(periodId));
        planInfo = PerfPlanFactory.getLocalInstance(ctx).getPerfPlanInfo(new ObjectUuidPK(perfPeriodInfo.getPerfPlan().getId().toString()));
        String sql = " select t.fid from t_eva_perfperiod t    left outer join t_eva_perfplan tt     on t.fperfplan = tt.fid   where t.fnumber ='" + perfPeriodInfo.getNumber() + "'     and tt.fperfmodelid = '" + planInfo.getPerfModel().getId().toString() + "'    and tt.FHrUnitOrgID = '" + hrOrgUnit + "'";
        return sql;
    }
}
