package com.kingdee.eas.hr.project.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.project.IProjectChange;
import com.kingdee.eas.hr.project.IProjectManagement;
import com.kingdee.eas.hr.project.ProjectChangeFactory;
import com.kingdee.eas.hr.project.ProjectChangeInfo;
import com.kingdee.eas.hr.project.ProjectManagementFactory;
import com.kingdee.eas.hr.project.ProjectManagementInfo;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.handler.EditHandler;
import com.kingdee.shr.common.util.StringUtils;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.ui.ModelMap;

public class ProjectChangeEditHandler extends EditHandler
{
  private static final Logger logger = LoggerFactory.getLogger(ProjectChangeEditHandler.class);

  protected void verifyModel(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model)
    throws SHRWebException
  {
    try
    {
      super.verifyModel(request, response, model);
      if ((model instanceof ProjectChangeInfo))
      {
        ProjectChangeInfo info = (ProjectChangeInfo)model;
        ObjectUuidPK objectUuidPK = new ObjectUuidPK(info.getChangeProject().getId());
        IProjectManagement iProjectManagement = ProjectManagementFactory.getRemoteInstance();
        ProjectManagementInfo projectManagementInfo = iProjectManagement.getProjectManagementInfo(objectUuidPK);
        if(info.getId() != null ) {
        	if(projectManagementInfo.isBeingChanged() && !projectManagementInfo.getSourceBillId().equals(info.getId().toString())){
        		throw new ShrWebBizException("ʧܣĿڱܶα!");
        	}
        }else {
        	if (projectManagementInfo.isBeingChanged()) {
            	throw new ShrWebBizException("ʧܣĿڱܶα!");
            }
        }
        
      }
    } catch (EASBizException e) {
      e.printStackTrace();
    } catch (BOSException e) {
      e.printStackTrace();
    }
  }

  public String submitAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
    throws SHRWebException
  {
    Context ctx = SHRContext.getInstance().getContext();
    String billId = request.getParameter("billId");
    Map result = new HashMap();
    if (!StringUtils.isEmpty(billId)) {
      try {
        IProjectChange iProjectChange = ProjectChangeFactory.getLocalInstance(ctx);
        ProjectChangeInfo projectChangeInfo = iProjectChange.getProjectChangeInfo("where id = '" + billId + "'");
        ProjectManagementInfo changeProjectInfo = projectChangeInfo.getChangeProject();
        changeProjectInfo.setBeingChanged(true);
        changeProjectInfo.setSourceBillId(projectChangeInfo.getId().toString());
        IProjectManagement iProjectManagement = ProjectManagementFactory.getLocalInstance(ctx);
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add(new SelectorItemInfo("beingChanged"));
        sic.add(new SelectorItemInfo("sourceBillId"));
        iProjectManagement.updatePartial(changeProjectInfo, sic);
      } catch (Exception var9) {
        logger.error(var9.getMessage(), var9);
        throw new ShrWebBizException("Ŀʧܣ", var9);
      }
    }
    return super.submitAction(request, response, modelMap);
  }
  
//  public void auditPorjectAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
//    throws SHRWebException, BOSException, EASBizException
//  {
//    Context ctx = SHRContext.getInstance().getContext();
//    String billId = request.getParameter("billId");
//    Map result = new HashMap();
//    if (!StringUtils.isEmpty(billId))
//      try {
//        IProjectChange iProjectChange = ProjectChangeFactory.getLocalInstance(ctx);
//        ProjectChangeInfo projectChangeInfo = iProjectChange.getProjectChangeInfo("where id = '" + billId + "'");
//
//        BigDecimal chaManDays = projectChangeInfo.getChaManDays();
//        BigDecimal oriManDays = projectChangeInfo.getOriManDays();
//        BigDecimal changedManDays = chaManDays.subtract(oriManDays);
//
//        ProjectManagementInfo changeProject = projectChangeInfo.getChangeProject();
//        changeProject.setChangedManDays(changedManDays);
//        System.out.print("ֵֵɹ" + changedManDays);
//        changeProject.setBeingChanged(false);
//        System.out.print("ǷֵΪfalse");
//
//        BigDecimal oriManDays2 = projectChangeInfo.getOriManDays();
//        System.out.print("Ŀֵȡɹ" + oriManDays2);
//        BigDecimal add = oriManDays2.add(changedManDays);
//        System.out.print("ֵۼӳɹ" + add);
//
//        changeProject.setTotalPersonDays(add);
//        System.out.print("ۼӺֵֵĿɹ");
//
//        IProjectManagement iProjectManagement = ProjectManagementFactory.getLocalInstance(ctx);
//        SelectorItemCollection sic = new SelectorItemCollection();
//
//        sic.add(new SelectorItemInfo("changedManDays"));
//        sic.add(new SelectorItemInfo("beingChanged"));
//        System.out.print("³ɹ");
//
//        sic.add(new SelectorItemInfo("totalPersonDays"));
//        System.out.print("Ŀ³ɹɹ");
//
//        iProjectManagement.updatePartial(changeProject, sic);
//      } catch (Exception var9) {
//        logger.error(var9.getMessage(), var9);
//        throw new ShrWebBizException("Ŀʧܣ", var9);
//      }
//    else {
//      result.put("errorMsg", "쳣billIdΪգ");
//    }
//
//    JSONUtils.writeJson(response, result);
//  }
}