package com.kingdee.eas.hr.project.handler;

import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemCollection;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.dynamic.model.ListUIViewInfo;
import com.kingdee.shr.base.syssetting.web.dynamic.model.TreeNavigationInfo;
import com.kingdee.shr.base.syssetting.web.dynamic.model.UIViewInfo;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;

import javax.servlet.http.HttpServletRequest;

public class ProjectTreeListHandler extends ListHandler {
    @Override
    protected UIViewInfo getUIViewInfo(HttpServletRequest request) throws SHRWebException {
        ListUIViewInfo uiViewInfo = (ListUIViewInfo) super.getUIViewInfo(request);
        TreeNavigationInfo treeNavigation = uiViewInfo.getTreeNavigation();
        treeNavigation.setBuilder("com.kingdee.eas.hr.project.builder.ProjectMTreeBuilder");
        return uiViewInfo;
    }
    protected FilterInfo getTreeDomainFilter(HttpServletRequest request) throws SHRWebException {
        FilterInfo ifo = null;
        FilterInfo filterInfo = super.getTreeDomainFilter(request);
        if(null!=filterInfo) {
            FilterItemCollection fcs = filterInfo.getFilterItems();
            ifo = new FilterInfo();
            if ((!fcs.isEmpty() && fcs.size() > 0)) {
                FilterItemInfo filterItemInfo = fcs.get(0);
                String str = filterItemInfo.toString();
                ifo.getFilterItems().add(new FilterItemInfo(str.replaceAll("longNumber","id")));
            }
        }
        return ifo;
    }
}
