package com.kingdee.eas.hr.project.service;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.eas.hr.project.IWorkHoursReport;
import com.kingdee.eas.hr.project.WorkHoursReportFactory;
import com.kingdee.eas.hr.project.WorkHoursReportInfo;

import java.util.HashMap;
import java.util.Map;

/**
 * @author qingwu
 * @date 2024/12/12
 * @apiNote
 */
public class WorkHoursReportService implements IHRMsfService {

    @Override
    public Object process(Context context, Map<String, Object> map) throws EASBizException, BOSException {
        System.out.println("WorkHoursReportService---");
        String billId = (String) map.get("billId");
        String status = (String) map.get("status");
        IWorkHoursReport iWorkHoursReport = WorkHoursReportFactory.getLocalInstance(context);
        Map resutlMap = new HashMap();
        WorkHoursReportInfo workHoursReportInfo = iWorkHoursReport.getWorkHoursReportInfo(new ObjectUuidPK(billId));
        if ("1".equals(status)) {//ύ
            IObjectPK submit = iWorkHoursReport.submit(workHoursReportInfo);
            if (submit != null) {
                System.out.println("submit---" + submit);
                resutlMap.put("IObjectPK", submit);
                resutlMap.put("msg", "ύɹ");
                resutlMap.put("code", "200");
                SelectorItemCollection sic = new SelectorItemCollection();
                sic.add("billState");
                WorkHoursReportInfo ifno = iWorkHoursReport.getWorkHoursReportInfo(submit);
                ifno.setBillState(HRBillStateEnum.AUDITING);
                System.out.println("getBillState---" + ifno.getBillState().getAlias());
                iWorkHoursReport.updatePartial(ifno, sic);
            } else {
                resutlMap.put("code", "500");
                resutlMap.put("msg", "ύʧ");
            }
            return resutlMap;
        }
        if ("2".equals(status)) {//
            //iWorkHoursReport.abortBizBill(billId);
            iWorkHoursReport.revise(new ObjectUuidPK(billId), workHoursReportInfo);
            resutlMap.put("msg", "سɹ");
            resutlMap.put("code", "200");
            return resutlMap;
        }
        return null;
    }
}
